--- /sys/dev/twa/tw_osl_freebsd.c	Wed Dec  7 13:18:05 2005
+++ /sys/dev/twa/tw_osl_freebsd.c	Thu Apr 27 12:50:12 2006
@@ -89,6 +89,7 @@
 	TW_INT32		unit = minor(dev);
 	struct twa_softc	*sc = devclass_get_softc(twa_devclass, unit);
 
+
 	tw_osli_dbg_dprintf(5, sc, "entered");
 	sc->state |= TW_OSLI_CTLR_STATE_OPEN;
 	return(0);
@@ -144,7 +145,6 @@
 {
 	struct twa_softc	*sc = (struct twa_softc *)(dev->si_drv1);
 	TW_INT32		error;
-
 	tw_osli_dbg_dprintf(5, sc, "entered");
 
 	switch (cmd) {
@@ -224,6 +224,7 @@
 {
 	static TW_UINT8	first_ctlr = 1;
 
+
 	tw_osli_dbg_printf(3, "entered");
 
 	if (tw_cl_ctlr_supported(pci_get_vendor(dev), pci_get_device(dev))) {
@@ -264,6 +265,7 @@
 	TW_INT32		bar_size;
 	TW_INT32		error;
 
+
 	tw_osli_dbg_dprintf(3, sc, "entered");
 
 	sc->ctlr_handle.osl_ctlr_ctxt = sc;
@@ -279,6 +281,8 @@
 	mtx_init(sc->q_lock, "tw_osl_q_lock", NULL, MTX_SPIN);
 
 	sysctl_ctx_init(&sc->sysctl_ctxt);
+
+
 	sc->sysctl_tree = SYSCTL_ADD_NODE(&sc->sysctl_ctxt,
 		SYSCTL_STATIC_CHILDREN(_hw), OID_AUTO,
 		device_get_nameunit(dev), CTLFLAG_RD, 0, "");
@@ -308,6 +312,7 @@
 		return(ENXIO);
 	}
 
+
 	/* Force the busmaster enable bit on, in case the BIOS forgot. */
 	command |= PCIM_CMD_BUSMASTEREN;
 	pci_write_config(dev, PCIR_COMMAND, command, 2);
@@ -340,6 +345,7 @@
 	sc->bus_tag = rman_get_bustag(sc->reg_res);
 	sc->bus_handle = rman_get_bushandle(sc->reg_res);
 
+
 	/* Allocate and register our interrupt. */
 	sc->irq_res_id = 0;
 	if ((sc->irq_res = bus_alloc_resource(sc->bus_dev, SYS_RES_IRQ,
@@ -386,6 +392,7 @@
 		return(error);
 	}
 
+
 	/* Initialize the Common Layer for this controller. */
 	if ((error = tw_cl_init_ctlr(&sc->ctlr_handle, sc->flags, sc->device_id,
 			TW_OSLI_MAX_NUM_IOS, TW_OSLI_MAX_NUM_AENS,
@@ -467,7 +474,8 @@
 	TW_UINT32			per_req_dma_mem_size;
 #endif /* TW_OSL_DMA_MEM_ALLOC_PER_REQUEST */
 	TW_INT32			error;
-	TW_INT32			i;
+	TW_INT32			i = 0;
+
 
 	tw_osli_dbg_dprintf(3, sc, "entered");
 
@@ -700,10 +708,11 @@
 	tw_osli_req_q_init(sc, TW_OSLI_FREE_Q);
 	tw_osli_req_q_init(sc, TW_OSLI_BUSY_Q);
 
+
 	if ((sc->req_ctxt_buf = (struct tw_osli_req_context *)
 			malloc((sizeof(struct tw_osli_req_context) *
 				TW_OSLI_MAX_NUM_IOS),
-				TW_OSLI_MALLOC_CLASS, M_WAITOK)) == NULL) {
+				TW_OSLI_MALLOC_CLASS, M_WAITOK | M_ZERO)) == NULL) {
 		tw_osli_printf(sc, "error = %d",
 			TW_CL_SEVERITY_ERROR_STRING,
 			TW_CL_MESSAGE_SOURCE_FREEBSD_DRIVER,
@@ -712,21 +721,39 @@
 			ENOMEM);
 		return(ENOMEM);
 	}
-	bzero(sc->req_ctxt_buf,
-		sizeof(struct tw_osli_req_context) * TW_OSLI_MAX_NUM_IOS);
+	
+	bus_dmamap_t* dma_v = (bus_dmamap_t*)malloc(sizeof(bus_dmamap_t) * TW_OSLI_MAX_NUM_IOS, M_DEVBUF, M_WAITOK | M_ZERO);
 
+	if(dma_v == NULL) {
+		return(ENOMEM);
+	}
+
+	if(bus_dmamap_create_v(sc->dma_tag, 0, dma_v, TW_OSLI_MAX_NUM_IOS)) { 
+		tw_osli_printf(sc, "request # = %d, error = %d",
+			TW_CL_SEVERITY_ERROR_STRING,
+			TW_CL_MESSAGE_SOURCE_FREEBSD_DRIVER,
+			0x2013,
+			"Can't create dma map",
+			i, ENOMEM);
+
+		return(ENOMEM);
+	}
+
+	// XXX should be i < ...
 	for (i = 0; i < TW_OSLI_MAX_NUM_IOS; i++) {
 		req = &(sc->req_ctxt_buf[i]);
 		req->ctlr = sc;
-		if (bus_dmamap_create(sc->dma_tag, 0, &req->dma_map)) {
+		req->dma_map = dma_v[i];
+	/*	if (bus_dmamap_create(sc->dma_tag, 0, &req->dma_map)) {
 			tw_osli_printf(sc, "request # = %d, error = %d",
 				TW_CL_SEVERITY_ERROR_STRING,
 				TW_CL_MESSAGE_SOURCE_FREEBSD_DRIVER,
 				0x2013,
 				"Can't create dma map",
 				i, ENOMEM);
+
 			return(ENOMEM);
-		}
+		}*/
 
 #ifdef TW_OSL_DMA_MEM_ALLOC_PER_REQUEST
 
@@ -734,11 +761,12 @@
 			(i * per_req_dma_mem_size);
 		req->req_pkt.dma_mem_phys = sc->dma_mem_phys +
 			(i * per_req_dma_mem_size);
-
+	
 #endif /* TW_OSL_DMA_MEM_ALLOC_PER_REQUEST */
-
+	
 		/* Insert request into the free queue. */
 		tw_osli_req_q_insert_tail(req, TW_OSLI_FREE_Q);
+
 	}
 
 #ifdef TW_OSL_DMA_MEM_ALLOC_PER_REQUEST
@@ -962,10 +990,12 @@
 	lock = (struct mtx *)lock_arg;
 	switch (op) {
 	case BUS_DMA_LOCK:
+		printf("twa: Locking!\n");
 		mtx_lock_spin(lock);
 		break;
 
 	case BUS_DMA_UNLOCK:
+		printf("twa: Unlocking!\n");
 		mtx_unlock_spin(lock);
 		break;
 
